Package de.willuhn.jameica.hbci.rmi

# Interface UmsatzTyp

All Superinterfaces:
  `de.willuhn.datasource.rmi.Changeable`, `de.willuhn.datasource.rmi.DBObject`, `de.willuhn.datasource.rmi.DBObjectNode`, `de.willuhn.datasource.GenericObject`, `de.willuhn.datasource.GenericObjectNode`, `Remote`, `de.willuhn.datasource.rmi.Transactionable`

All Known Implementing Classes:
  `UmsatzTypImpl`, `UmsatzTypUtil.UmsatzTypUnassigned`

public interface UmsatzTyp extends de.willuhn.datasource.rmi.DBObjectNode
Interface zur Einstufung von Umsaetzen in verschiedene Kategorien.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`FLAG_NONE`
Flag "kein Flag".
`static final int`
`FLAG_SKIP_REPORTS`
Flag "In Auswertungen ignorieren".
`static final int`
`MAXLENGTH_PATTERN`
Maximale Laenge des Pattern.
`static final int`
`TYP_AUSGABE`
Umsatzkategorie vom Typ "Ausgabe".
`static final int`
`TYP_EGAL`
Umsatzkategorie vom Typ "Egal".
`static final int`
`TYP_EINNAHME`
Umsatzkategorie vom Typ "Einnahme".

## Method Summary

Modifier and Type
Method
Description
`int[]`
`getColor()`
Liefert die fuer diese Kategorie zu verwendende Farbe.
`int`
`getFlags()`
Liefert ein Bit-Feld mit Flags.
`String`
`getKommentar()`
Liefert den Kommentar fuer den Umsatztyp.
`Konto`
`getKonto()`
Liefert das optional zugeordnete Konto.
`String`
`getKontoKategorie()`
Liefert eine optionale Konto-Kategorie.
`String`
`getName()`
Liefert den Namen des Umsatz-Typs.
`String`
`getNummer()`
Liefert die Nummer des Umsatz-Typs.
`String`
`getPath(String sep)`
Liefert einen Pfad mit den Namen der Kategorien bis zur obersten Ebene.
`String`
`getPattern()`
Liefert das Suchmuster fuer den Umsatztyp.
`int`
`getTyp()`
Liefert den Typ der Kategorie.
`de.willuhn.datasource.GenericIterator`
`getUmsaetze()`
Liefert eine Liste von Umsaetzen, die diesem Umsatz-Typ entsprechen.
`de.willuhn.datasource.GenericIterator`
`getUmsaetze(int days)`
Liefert eine Liste von Umsaetzen der letzten Tage, die diesem Umsatz-Typ entsprechen.
`de.willuhn.datasource.GenericIterator`
`getUmsaetze(Date von, Date bis)`
Liefert eine Liste von Umsaetzen aus dem angegebenen Zeitraum.
`double`
`getUmsatz()`
Liefert die Hoehe des Umsatzes, der fuer diesen Umsatztyp auf allen Konten vorliegt.
`double`
`getUmsatz(int days)`
Liefert die Hoehe des Umsatzes der letzten Tage, der fuer diesen Umsatztyp auf allen Konten vorliegt.
`double`
`getUmsatz(Date von, Date bis)`
Liefert die Hoehe des Umsatzes aus dem angegebenen Zeitraum.
`boolean`
`hasFlag(int flag)`
Prueft, ob das angegebene Flag vorhanden ist.
`boolean`
`isCustomColor()`
Prueft, ob eine benutzerdefinierte Farbe verwendet werden soll.
`boolean`
`isRegex()`
Prueft, ob es sich bei dem Pattern um einen regulaeren Ausdruck handelt.
`boolean`
`matches(Umsatz umsatz)`
Prueft, ob der Umsatz diesem Pattern entspricht.
`boolean`
`matches(Umsatz umsatz, boolean allowReassign)`
Prueft, ob der Umsatz diesem Pattern entspricht.
`void`
`setColor(int[] rgb)`
Speichert die Farbe fuer die Umsatz-Kategorie.
`void`
`setCustomColor(boolean b)`
Legt fest, ob eine benutzerdefinierte Farbe verwendet werden soll.
`void`
`setFlags(int flags)`
Speichert die Flags einen Objektes.
`void`
`setKommentar(String kommentar)`
Speichert den Kommentar fuer den Umsatztyp.
`void`
`setKonto(Konto konto)`
Speichert das optional zugeordnete Konto.
`void`
`setKontoKategorie(String kategorie)`
Speichert eine optionale Konto-Kategorie.
`void`
`setName(String name)`
Speichert den Namen des Umsatz-Typs.
`void`
`setNummer(String nummer)`
Speichert die Nummer des Umsatz-Typs.
`void`
`setPattern(String pattern)`
Speichert das Suchmuster fuer den Umsatztyp.
`void`
`setRegex(boolean regex)`
Speichert, ob es sich bei dem Pattern um einen regulaeren Ausdruck handelt.
`void`
`setTyp(int typ)`
Speichert den Typ der Kategorie.

### Methods inherited from interface de.willuhn.datasource.rmi.Changeable

`clear, delete, isNewObject, overwrite, store`

### Methods inherited from interface de.willuhn.datasource.rmi.DBObject

`addDeleteListener, addStoreListener, equals, getAttribute, getAttributeType, getList, getPrimaryAttribute, load, removeDeleteListener, removeStoreListener`

### Methods inherited from interface de.willuhn.datasource.rmi.DBObjectNode

`getTopLevelList, setParent`

### Methods inherited from interface de.willuhn.datasource.GenericObject

`getAttributeNames, getID`

### Methods inherited from interface de.willuhn.datasource.GenericObjectNode

`getChildren, getParent, getPath, getPossibleParents, hasChild`

### Methods inherited from interface de.willuhn.datasource.rmi.Transactionable

`transactionBegin, transactionCommit, transactionRollback`

## Field Details

### TYP_AUSGABE

static final int TYP_AUSGABE
Umsatzkategorie vom Typ "Ausgabe".

See Also:
  - Constant Field Values

### TYP_EINNAHME

static final int TYP_EINNAHME
Umsatzkategorie vom Typ "Einnahme".

See Also:
  - Constant Field Values

### TYP_EGAL

static final int TYP_EGAL
Umsatzkategorie vom Typ "Egal".

See Also:
  - Constant Field Values

### MAXLENGTH_PATTERN

static final int MAXLENGTH_PATTERN
Maximale Laenge des Pattern.

See Also:
  - Constant Field Values

### FLAG_NONE

static final int FLAG_NONE
Flag "kein Flag".

See Also:
  - Constant Field Values

### FLAG_SKIP_REPORTS

static final int FLAG_SKIP_REPORTS
Flag "In Auswertungen ignorieren".

See Also:
  - Constant Field Values

## Method Details

### getName

String getName() throws RemoteException
Liefert den Namen des Umsatz-Typs.

Returns:
  Name des Umsatz-Typs.
Throws:
  `RemoteException`

### setName

void setName(String name) throws RemoteException
Speichert den Namen des Umsatz-Typs.

Parameters:
  `name` - Name des Umsatz-Typs.
Throws:
  `RemoteException`

### getNummer

String getNummer() throws RemoteException
Liefert die Nummer des Umsatz-Typs. Die Nummer wird für die Sortierung bei der Auswertung eingesetzt.

Returns:
  Nummer des Umsatz-Typs.
Throws:
  `RemoteException`

### setNummer

void setNummer(String nummer) throws RemoteException
Speichert die Nummer des Umsatz-Typs.

Parameters:
  `nummer` - Nummer des Umsatz-Typs
Throws:
  `RemoteException`

### getPattern

String getPattern() throws RemoteException
Liefert das Suchmuster fuer den Umsatztyp.

Returns:
  Suchmuster.
Throws:
  `RemoteException`

### setKommentar

void setKommentar(String kommentar) throws RemoteException
Speichert den Kommentar fuer den Umsatztyp.

Parameters:
  `kommentar` - der Kommentar.
Throws:
  `RemoteException`

### getKommentar

String getKommentar() throws RemoteException
Liefert den Kommentar fuer den Umsatztyp.

Returns:
  Kommentar.
Throws:
  `RemoteException`

### setPattern

void setPattern(String pattern) throws RemoteException
Speichert das Suchmuster fuer den Umsatztyp.

Parameters:
  `pattern` - das Suchmuster.
Throws:
  `RemoteException`

### getUmsaetze

de.willuhn.datasource.GenericIterator getUmsaetze() throws RemoteException
Liefert eine Liste von Umsaetzen, die diesem Umsatz-Typ entsprechen.

Returns:
  Umsatz-Liste.
Throws:
  `RemoteException`

### getUmsaetze

de.willuhn.datasource.GenericIterator getUmsaetze(Date von, Date bis) throws RemoteException
Liefert eine Liste von Umsaetzen aus dem angegebenen Zeitraum.

Parameters:
  `von` - Start-Datum. Wenn == null, dann bleibt es unberücksichtigt.
  `bis` - Ende-Datum. Wenn == null, dann bleibt es unberücksichtigt.
Returns:
  Umsatz-Liste.
Throws:
  `RemoteException`

### getUmsaetze

de.willuhn.datasource.GenericIterator getUmsaetze(int days) throws RemoteException
Liefert eine Liste von Umsaetzen der letzten Tage, die diesem Umsatz-Typ entsprechen.

Parameters:
  `days` - Anzahl der Tage.
Returns:
  Umsatz-Liste.
Throws:
  `RemoteException`

### getUmsatz

double getUmsatz() throws RemoteException
Liefert die Hoehe des Umsatzes, der fuer diesen Umsatztyp auf allen Konten vorliegt.

Returns:
  Hoehe des Umsatzes.
Throws:
  `RemoteException`

### getUmsatz

double getUmsatz(Date von, Date bis) throws RemoteException
Liefert die Hoehe des Umsatzes aus dem angegebenen Zeitraum.

Parameters:
  `von` - Start-Datum. Wenn == null, dann bleibt es unberücksichtigt.
  `bis` - Ende-Datum. Wenn == null, dann bleibt es unberücksichtigt.
Returns:
  Hoehe des Umsatzes.
Throws:
  `RemoteException`

### getUmsatz

double getUmsatz(int days) throws RemoteException
Liefert die Hoehe des Umsatzes der letzten Tage, der fuer diesen Umsatztyp auf allen Konten vorliegt.

Parameters:
  `days` - Anzahl der Tage.
Returns:
  Hoehe des Umsatzes.
Throws:
  `RemoteException`

### isRegex

boolean isRegex() throws RemoteException
Prueft, ob es sich bei dem Pattern um einen regulaeren Ausdruck handelt.

Returns:
  true, wenn es sich um einen regulaeren Ausdruck handelt.
Throws:
  `RemoteException`

### getTyp

int getTyp() throws RemoteException
Liefert den Typ der Kategorie.

Returns:
  Typ der Kategorie.
Throws:
  `RemoteException`
See Also:
  - `TYP_AUSGABE`
  - `TYP_EINNAHME`
  - `TYP_EGAL`

### setTyp

void setTyp(int typ) throws RemoteException
Speichert den Typ der Kategorie.

Parameters:
  `typ` - Typ der Kategorie.
Throws:
  `RemoteException`
See Also:
  - `TYP_AUSGABE`
  - `TYP_EINNAHME`
  - `TYP_EGAL`

### setRegex

void setRegex(boolean regex) throws RemoteException
Speichert, ob es sich bei dem Pattern um einen regulaeren Ausdruck handelt.

Parameters:
  `regex` - true, wenn es sich um einen regulaeren Ausdruck handelt.
Throws:
  `RemoteException`

### matches

boolean matches(Umsatz umsatz) throws RemoteException, PatternSyntaxException
Prueft, ob der Umsatz diesem Pattern entspricht. Ist fuer den Umsatz-Typ kein Pattern definiert, liefert die Funktion immer false.

Parameters:
  `umsatz` - zu pruefender Umsatz.
Returns:
  true, wenn er dem Pattern entspricht.
Throws:
  `RemoteException`
  `PatternSyntaxException` - wird geworden, wenn es ein regulaerer Ausdruck mit Fehlern ist.

### matches

boolean matches(Umsatz umsatz, boolean allowReassign) throws RemoteException, PatternSyntaxException
Prueft, ob der Umsatz diesem Pattern entspricht. Ist fuer den Umsatz-Typ kein Pattern definiert, liefert die Funktion immer false.

Parameters:
  `umsatz` - zu pruefender Umsatz.
  `allowReassign` - true, wenn der Umsatz auch dann als passend gewertet werden soll, wenn er bereits fest einer anderen Kategorie zugeordnet ist. Per Default (also wenn die "matches(Umsatz)"-Funktion ohne diesen Boolean-Parameter aufgerufen wird) ist dieser Parameter "false". Das heisst, ein Umsatz, der bereits manuell (nicht per Suchbegriff) einer anderen Kategorie zugeordnet ist, liefert hier false, wenn "this" nicht die zugeordnete Kategorie ist.
Returns:
  true, wenn er dem Pattern entspricht.
Throws:
  `RemoteException`
  `PatternSyntaxException` - wird geworden, wenn es ein regulaerer Ausdruck mit Fehlern ist.

### getColor

int[] getColor() throws RemoteException
Liefert die fuer diese Kategorie zu verwendende Farbe.

Returns:
  Farbe oder null, wenn noch keine definiert wurde.
Throws:
  `RemoteException`

### setColor

void setColor(int[] rgb) throws RemoteException
Speichert die Farbe fuer die Umsatz-Kategorie.

Parameters:
  `rgb` - Farbe.
Throws:
  `RemoteException`

### isCustomColor

boolean isCustomColor() throws RemoteException
Prueft, ob eine benutzerdefinierte Farbe verwendet werden soll.

Returns:
  true, wenn eine benutzerdefinierte Farbe verwendet werden soll.
Throws:
  `RemoteException`

### setCustomColor

void setCustomColor(boolean b) throws RemoteException
Legt fest, ob eine benutzerdefinierte Farbe verwendet werden soll.

Parameters:
  `b` - true, wenn eine benutzerdefinierte Farbe verwendet werden soll.
Throws:
  `RemoteException`

### getKonto

Konto getKonto() throws RemoteException
Liefert das optional zugeordnete Konto.

Returns:
  Konto.
Throws:
  `RemoteException`

### setKonto

void setKonto(Konto konto) throws RemoteException
Speichert das optional zugeordnete Konto.

Parameters:
  `konto` - Konto.
Throws:
  `RemoteException`

### getKontoKategorie

String getKontoKategorie() throws RemoteException
Liefert eine optionale Konto-Kategorie.

Returns:
  eine optionale Konto-Kategorie.
Throws:
  `RemoteException`

### setKontoKategorie

void setKontoKategorie(String kategorie) throws RemoteException
Speichert eine optionale Konto-Kategorie.

Parameters:
  `kategorie` - die optionale Konto-Kategorie.
Throws:
  `RemoteException`

### getFlags

int getFlags() throws RemoteException
Liefert ein Bit-Feld mit Flags. Ein Objekt kann mit verschiedenen Flags markiert werden. Das kann zum Beispiel "deaktiviert" sein. Damit fuer kuenftige weitere Flags nicht immer ein neues Feld zur Datenbank hinzugefuegt werden muss, verwenden wir hier ein Bitfeld. Damit koennen mehrere Flags in einem Wert codiert werden.

Returns:
  Bit-Feld mit den Flags des Objektes.
Throws:
  `RemoteException`

### setFlags

void setFlags(int flags) throws RemoteException
Speichert die Flags einen Objektes.

Parameters:
  `flags` - die Flags in Form eines Bit-Feldes.
Throws:
  `RemoteException`

### hasFlag

boolean hasFlag(int flag) throws RemoteException
Prueft, ob das angegebene Flag vorhanden ist.

Parameters:
  `flag` - das zu pruefende Flag.
Returns:
  true, wenn es gesetzt ist.
Throws:
  `RemoteException`

### getPath

String getPath(String sep) throws RemoteException
Liefert einen Pfad mit den Namen der Kategorien bis zur obersten Ebene.

Parameters:
  `sep` - das Trennzeichen.
Returns:
  der Pfad.
Throws:
  `RemoteException`